import { __assign } from 'tslib';
import { Injectable, Component, ChangeDetectionStrategy, EventEmitter, ChangeDetectorRef, Input, Output, ContentChild, Pipe, NgModule } from '@angular/core';
import { Subject } from 'rxjs';
import { FormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { NgxPaginationModule } from 'ngx-pagination';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DataShowingService = /** @class */ (function () {
    function DataShowingService() {
        this.dataShowingSubject = new Subject();
    }
    /**
     * @param {?} data
     * @return {?}
     */
    DataShowingService.prototype.setSataShowingSubject = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.dataShowingSubject.next(data);
    };
    DataShowingService.decorators = [
        { type: Injectable }
    ];
    return DataShowingService;
}());
if (false) {
    /** @type {?} */
    DataShowingService.prototype.dataShowingSubject;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CaptionComponent = /** @class */ (function () {
    function CaptionComponent() {
    }
    /**
     * @return {?}
     */
    CaptionComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    CaptionComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-caption',
                    template: "\n        \n<ng-content></ng-content>\n\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    CaptionComponent.ctorParameters = function () { return []; };
    return CaptionComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxDatatableComponent = /** @class */ (function () {
    function NgxDatatableComponent(dataShowingService, cdr) {
        this.dataShowingService = dataShowingService;
        this.cdr = cdr;
        this.ngUnsubscribe = new Subject();
        this.customOptions = {
            'emptyDataMessage': 'No data available in table',
            'rowClickEvent': false,
            'rowPerPageMenu': [10, 20, 50, 100],
            'rowPerPage': 10,
            'loader': false,
            'checkboxes': false,
            'rowDetailTemplate': undefined
        };
        this._options = {};
        this._data = [];
        this.tableId = 'ngxDataTableId';
        this.columns = [];
        this.rowClick = new EventEmitter();
        this.checkboxClick = new EventEmitter();
        this.searchText = "";
        this.currentPage = 1;
        this.orderBy = { order: '', key: '' };
        this.dataShowing = { start: 0, end: 0, len: 0 };
        this.styleParams = { pinnedScollerMarginLeft: 0, pinnedFlag: false };
        this.selectedCheckboxes = new Set();
        this.selectedCheckList = [];
        this.openRowDetailsId = new Set();
    }
    Object.defineProperty(NgxDatatableComponent.prototype, "data", {
        get: /**
         * @return {?}
         */
        function () {
            return this._data;
        },
        set: /**
         * @param {?} arr
         * @return {?}
         */
        function (arr) {
            var _this = this;
            this._data = [];
            arr.forEach((/**
             * @param {?} item
             * @param {?} index
             * @return {?}
             */
            function (item, index) {
                _this._data.push(__assign({}, item, { '_autoId': index }));
            }));
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(NgxDatatableComponent.prototype, "options", {
        get: /**
         * @return {?}
         */
        function () {
            return this._options;
        },
        set: /**
         * @param {?} obj
         * @return {?}
         */
        function (obj) {
            this._options = __assign({}, this.customOptions, this._options, obj);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NgxDatatableComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.columns.map((/**
         * @param {?} item
         * @param {?} i
         * @return {?}
         */
        function (item, i) {
            item['sorting'] = item.hasOwnProperty('sorting') ? item['sorting'] : true;
            item['headAlign'] = item.hasOwnProperty('headAlign') ? item['headAlign'].toLowerCase() : 'left';
            item['sortingOrder'] = '';
            if ((item.hasOwnProperty('pinned') && item['pinned'] == true)) {
                /** working for pin the checkbox column */
                // this.styleParams['pinnedFlag'] = true;
                // if ( this.options.checkboxes == true && this.styleParams['pinnedFlag'] && i ==0) { 
                //     this.styleParams.pinnedScollerMarginLeft = 33;
                // }
                item['width'] = item.hasOwnProperty('width') ? item['width'] : 100;
                item['pinnedMarginLeft'] = _this.styleParams.pinnedScollerMarginLeft;
                _this.styleParams.pinnedScollerMarginLeft += parseInt(item['width']) + 20;
            }
        }));
        this.dataShowingFn(this.currentPage, this.options.rowPerPage, this.data.length);
        /** subscription list */
        this.dataShowingService.dataShowingSubject.subscribe((/**
         * @param {?} subData
         * @return {?}
         */
        function (subData) {
            subData['itemPerPage'] = subData.hasOwnProperty('itemPerPage') ? subData.itemPerPage : _this.options.rowPerPage;
            subData['currentPage'] = subData.hasOwnProperty('currentPage') ? subData.currentPage : _this.currentPage;
            subData['len'] = subData.hasOwnProperty('len') ? subData.len : _this.dataShowing.len;
            _this.dataShowingFn(subData.currentPage, subData.itemPerPage, subData.len);
        }));
    };
    /**
     * @return {?}
     */
    NgxDatatableComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        //console.log(this.headerRef);
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    NgxDatatableComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        //console.log(changes);
    };
    /**
     * @return {?}
     */
    NgxDatatableComponent.prototype.onInputSearch = /**
     * @return {?}
     */
    function () {
        this.currentPage = 1;
    };
    /**
     * @return {?}
     */
    NgxDatatableComponent.prototype.onChangeItemPerPage = /**
     * @return {?}
     */
    function () {
        this.currentPage = 1;
        this.dataShowingService.setSataShowingSubject({ 'currentPage': this.currentPage, 'itemPerPage': this.options.rowPerPage });
    };
    /**
     * @param {?} currentPage
     * @return {?}
     */
    NgxDatatableComponent.prototype.onPageChange = /**
     * @param {?} currentPage
     * @return {?}
     */
    function (currentPage) {
        this.currentPage = currentPage;
        this.dataShowingService.setSataShowingSubject({ 'currentPage': currentPage });
    };
    /**
     * @param {?} colItem
     * @param {?} index
     * @return {?}
     */
    NgxDatatableComponent.prototype.onClickOrderBy = /**
     * @param {?} colItem
     * @param {?} index
     * @return {?}
     */
    function (colItem, index) {
        if (colItem.sorting == true) {
            this.columns.map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { item.sortingOrder = ''; }));
            this.orderBy = __assign({}, this.orderBy, { 'order': this.orderBy.order == 'asc' ? 'desc' : 'asc', 'key': colItem.key });
            this.columns[index]['sortingOrder'] = this.orderBy.order;
        }
    };
    /**
     * @param {?} item
     * @return {?}
     */
    NgxDatatableComponent.prototype.onRowClick = /**
     * @param {?} item
     * @return {?}
     */
    function (item) {
        if (this.options.rowClickEvent)
            this.rowClick.emit(item);
    };
    /**
     * @param {?} rowObj
     * @return {?}
     */
    NgxDatatableComponent.prototype.onCheckboxSelect = /**
     * @param {?} rowObj
     * @return {?}
     */
    function (rowObj) {
        if (this.selectedCheckboxes.has(rowObj._autoId)) {
            this.selectedCheckboxes.delete(rowObj._autoId);
            this.selectedCheckList = this.selectedCheckList.filter((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                return item._autoId != rowObj._autoId;
            }));
        }
        else {
            this.selectedCheckboxes.add(rowObj._autoId);
            this.selectedCheckList.push(rowObj);
        }
        this.checkboxClick.emit(this.selectedCheckList);
    };
    /**
     * @param {?} checked
     * @return {?}
     */
    NgxDatatableComponent.prototype.onCheckboxSelectAll = /**
     * @param {?} checked
     * @return {?}
     */
    function (checked) {
        var _this = this;
        this.selectedCheckboxes = new Set();
        this.selectedCheckList = [];
        if (checked) {
            this.selectedCheckList = this.data.filter((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                _this.selectedCheckboxes.add(item._autoId);
                return true;
            }));
        }
        this.checkboxClick.emit(this.selectedCheckList);
    };
    /**
     * @param {?} rowObj
     * @return {?}
     */
    NgxDatatableComponent.prototype.onClickRowDettailArrowOpen = /**
     * @param {?} rowObj
     * @return {?}
     */
    function (rowObj) {
        if (this.openRowDetailsId.has(rowObj._autoId)) {
            this.openRowDetailsId.delete(rowObj._autoId);
        }
        else {
            this.openRowDetailsId.add(rowObj._autoId);
        }
    };
    /**
     * @return {?}
     */
    NgxDatatableComponent.prototype.onClickRowDettailAllArrowOpen = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.openRowDetailsId.size != this.data.length) {
            this.openRowDetailsId = new Set();
            this.data.filter((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                _this.openRowDetailsId.add(item._autoId);
                return true;
            }));
        }
        else {
            this.openRowDetailsId = new Set();
        }
    };
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    NgxDatatableComponent.prototype.identify = /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return index;
    };
    /**
     * @private
     * @param {?} currentPage
     * @param {?} itemPerPage
     * @param {?} length
     * @return {?}
     */
    NgxDatatableComponent.prototype.dataShowingFn = /**
     * @private
     * @param {?} currentPage
     * @param {?} itemPerPage
     * @param {?} length
     * @return {?}
     */
    function (currentPage, itemPerPage, length) {
        this.dataShowing.start = length == 0 ? 0 : ((currentPage - 1) * itemPerPage) + 1;
        this.dataShowing.end = currentPage * itemPerPage > length ? length : currentPage * itemPerPage;
        this.dataShowing.len = length;
    };
    NgxDatatableComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-datatable',
                    template: "\n<div  color=\"darken\" class=\"jarviswidget\">\n    <!-- table caption -->\n    <header *ngIf=\"captionRef\">\n        <ng-content select=\"ngx-caption\"></ng-content>\n    </header>\n    <div  class=\"dataTables_wrapper\">\n        <!-- search bar with page per item -->\n        <div class=\"row no-row-margin\" style=\"margin-top: 5px;\">\n            <div class=\"col-xs-6 col-sm-6 col-6 text-left\">\n                <label style=\"font-weight: 100;\">\n                    <input type=\"text\" \n                    [id]=\"'search_'+tableId\"\n                    [(ngModel)]=\"searchText\" \n                    (input)=\"onInputSearch()\"\n                    name=\"search\"\n                    placeholder=\"Search\"\n                    autocomplete=\"off\"\n                    style=\"border-radius: 0px;\"\n                    class=\"form-control input-md\"  />\n                </label>\n            </div>\n            <div class=\"col-sm-6 col-xs-6 col-6 text-right\">\n                <label style=\"font-weight: 100;\">\n                    <select (change)=\"onChangeItemPerPage()\" style=\"border-radius: 0px;\" [(ngModel)]=\"options.rowPerPage\" name=\"rowPerPage\" class=\"form-control\"  [id]=\"'itemPerPage_'+tableId\">\n                        <option *ngFor=\"let item of options.rowPerPageMenu\" [ngValue]=\"item\">{{item}}</option>\n                    </select>\n                </label>\n            </div>\n        </div>\n        <div class=\"zui-wrapper\">\n            <div class=\"zui-scroller\" [style.margin-left]=\"styleParams.pinnedScollerMarginLeft+'px'\" >\n                <table [id]=\"tableId\"  class=\" zui-table dataTable  {{tableClass}}\" role=\"grid\" aria-describedby=\"DataTables_Table_0_info\" width=\"100%\">\n                    <!-- table head code -->\n                    <thead _ngcontent-qqc-c0=\"\">\n                        <tr  role=\"row\" >\n                            <th *ngIf=\"options.rowDetailTemplate\" \n                                style= \" text-align: center; vertical-align: middle;\">\n                                <div (click)=\"onClickRowDettailAllArrowOpen()\"  \n                                    [class.triangle-right]=\"this.openRowDetailsId.size != this.data.length || this.data.length == 0 \" \n                                    [class.triangle-down]=\"this.openRowDetailsId.size == this.data.length && this.data.length != 0\">\n                                </div>\n                            </th>\n                            <!-- [style.min-width]=\"options.checkboxAsPin && styleParams.pinnedFlag ? '13px' : 'auto'\"\n                                [style.max-width]=\"options.checkboxAsPin && styleParams.pinnedFlag ? '13px' : 'auto'\"\n                                [class.zui-sticky-col]=\"options.checkboxAsPin && styleParams['pinnedFlag']\" -->\n                            <th *ngIf=\"options.checkboxes\"\n                                style= \"text-align: center; vertical-align: middle;\">\n                                    <input\n                                        class=\"ngx-form-checkbox-head\"\n                                        type=\"checkbox\"\n                                        id=\"checkbox-all\"\n                                        [checked]=\"this.selectedCheckboxes.size == this.data.length && this.data.length != 0\"\n                                        (change)=\"onCheckboxSelectAll($event.target.checked)\"\n                                    />\n                            </th>\n                            <th  *ngFor=\"let column of columns; let i = index; trackBy: identify\"\n                                (click)=\"onClickOrderBy(column, i)\"\n                                [style.min-width]=\"column.width+'px'\"\n                                [style.max-width]=\"column.width+'px'\" \n                                [style.vertical-align]=\"column.vAlign && column.vAlign.head\"\n                                [style.text-align]=\"column.align && column.align.head\"\n                                [class.zui-sticky-col]=\"column.pinned\"\n                                [style.margin-left]=\"column.pinnedMarginLeft+'px'\"yy>\n                                <span [innerHTML]=\"column.title\"\n                                    [class.wrap]=\"column.noWrap && column.noWrap.head\" \n                                    [class.sort-by] = \"column.sorting && column.sortingOrder==''\"\n                                    [class.sort-by-asc] = \"column.sorting && column.sortingOrder=='asc'\"\n                                    [class.sort-by-desc] = \"column.sorting && column.sortingOrder=='desc'\"\n                                 ></span>  \n                                <!-- [ngClass]=\"{sort-by:column.sorting==true, sort-by-asc:column.sorting==true&&column.sortingOrder=='asc', sort-by-desc:column.sorting==true&&column.sortingOrder=='desc'}\"  -->\n                                <!-- <div class=\"sorting\"style=\"display: inline;\"><span>&#8593;</span> <span>&#8595;</span></div>\t -->\n                            </th>\n                        </tr>\n                    </thead>\n                    <tbody>\n                        <ng-container *ngFor=\"let row of data \n                            | search:searchText \n                            | sort:orderBy \n                            | paginate: { id: 'pagination_'+tableId, itemsPerPage: options.rowPerPage, currentPage:currentPage }; \n                            trackBy: identify; let i = index;\">\n                            <tr [ngClass]=\"{ 'cus-cursor-pointer':options.rowClickEvent}\" \n                                (click)=\"onRowClick(row)\" >\n                                <!-- row Detail code -->\n                                <td *ngIf=\"options.rowDetailTemplate\"   \n                                    style= \" text-align: center; vertical-align: middle;\">\n                                    <div (click)=\"onClickRowDettailArrowOpen(row)\"  \n                                        [class.triangle-right]=\"!openRowDetailsId.has(row._autoId)\" \n                                        [class.triangle-down]=\"openRowDetailsId.has(row._autoId)\">\n                                    </div>\n                                </td>\n                                <!-- checck box code -->\n                                <!-- [style.min-width]=\"options.checkboxAsPin && styleParams.pinnedFlag ? '13px' : 'auto'\"\n                                    [style.max-width]=\"options.checkboxAsPin && styleParams.pinnedFlag ? '13px' : 'auto'\"\n                                    [class.zui-sticky-col]=\"options.checkboxAsPin && styleParams['pinnedFlag']\" -->\n                                <td *ngIf=\"options.checkboxes\"\n                                    style= \"text-align: center; vertical-align: middle;\">\n                                        <input\n                                            class=\"ngx-form-checkbox\"\n                                            type=\"checkbox\"\n                                            id=\"checkbox-{{row._autoId}}\"\n                                            [checked]=\"selectedCheckboxes.has(row._autoId)\"\n                                            (change)=\"onCheckboxSelect(row)\"\n                                        />\n                                </td>\n                                <!-- dynamacally generated column -->\n                                <td *ngFor=\"let column of columns;let j=index;\" \n                                    [style.min-width]=\"column.width+'px'\" \n                                    [style.max-width]=\"column.width+'px'\" \n                                    [class.wrap]=\"column.noWrap && column.noWrap.body\"\n                                    [style.vertical-align]=\"column.vAlign && column.vAlign.body\"\n                                    [style.text-align]=\"column.align && column.align.body\"\n                                    [class.zui-sticky-col]=\"column.pinned\"\n                                    [style.margin-left]=\"column.pinnedMarginLeft+'px'\"\n                                    >\n                                    <ng-container *ngIf=\"!column.cellTemplate\">{{row[column.key]}}</ng-container>\n                                    <ng-container *ngIf=\"column.cellTemplate\"\n                                        [ngTemplateOutlet]=\"column.cellTemplate\"\n                                        [ngTemplateOutletContext]=\"{\n                                            $implicit: row,\n                                            rowIndex: row._autoId,\n                                            columnValue: row[column.key]\n                                        }\"\n                                    >\n                                    </ng-container>\n                                    \n                                </td>\n                            </tr>\n                            <!-- row detail desccription code -->\n                            <tr *ngIf=\"options.rowDetailTemplate && openRowDetailsId.has(row._autoId) \" >\n                                <td [attr.colspan]=\"columns.length+(options.checkboxes?1:0)+(options.rowDetailTemplate?1:0)\" >\n                                    <ng-container\n                                        [ngTemplateOutlet]=\"options.rowDetailTemplate\"\n                                        [ngTemplateOutletContext]=\"{\n                                            $implicit: row,\n                                            rowIndex: row._autoId\n                                        }\"\n                                    >\n                                    </ng-container>\n                                </td>\n                            </tr>\n                        </ng-container>\n\n                        <tr class=\"odd\" *ngIf=\"!data.length && options.loader == false\" >\n                            <td valign=\"top\" [attr.colspan]=\"columns.length+(options.checkboxes?1:0)+(options.rowDetailTemplate?1:0)\" class=\"dataTables_empty\">\n                                {{options.emptyDataMessage}}\n                            </td>\n                        </tr>\n                        <tr class=\"odd\" *ngIf=\"options.loader == true\" >\n                            <td valign=\"top\" [attr.colspan]=\"columns.length+(options.checkboxes?1:0)+(options.rowDetailTemplate?1:0)\" class=\"dataTables_empty\">\n                                Loading...\n                            </td>\n                        </tr>\n                    </tbody>\n                </table>\n            </div>\n        </div>\n        <div class=\"row no-row-margin\" style=\"margin-top: 5px;\">\n            <div class=\"col-sm-6 col-xs-12 col-12 custom-data-entries-align\">\n                <div>Showing {{dataShowing.start}} to {{dataShowing.end}} of {{dataShowing.len}} entries</div>\n            </div>\n            <div class=\"col-xs-12 col-sm-6 col-12 custom-pagination-align\">\n                <pagination-controls [id]=\"'pagination_'+tableId\" (pageChange)=\"onPageChange($event)\"></pagination-controls>\n            </div>\n        </div>\n    </div>\n</div>\n\n\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [DataShowingService],
                    styles: [".jarviswidget{position:relative;border-radius:0;padding:0}.ui-sortable .jarviswidget-sortable>header{cursor:move;border-radius:0;line-height:normal;box-shadow:inset 0 -2px 0 rgba(0,0,0,.05);-moz-box-shadow:inset 0 -2px 0 rgba(0,0,0,.05);-webkit-box-shadow:inset 0 -2px 0 rgba(0,0,0,.05)}.ui-sortable .jarviswidget-sortable.jarviswidget-collapsed>header{border-radius:0}.jarviswidget-ctrls{width:auto;float:right;padding:0;margin:0}.jarviswidget-ctrls .button-icon{min-width:30px;height:32px;float:left;position:relative;font-family:Arial,Helvetica,sans-serif;border-left:1px solid rgba(0,0,0,.09)}.jarviswidget-ctrls .button-icon:hover{background-color:rgba(0,0,0,.05)}.jarviswidget-loader{width:32px;height:32px;margin:0;float:right;background-repeat:no-repeat;background-position:center center;display:none;text-align:center;line-height:32px;font-size:111%}.jarviswidget>div{border-top:none;float:left;width:100%;position:relative;font-size:13px;border-radius:0;margin:0;border-width:1px 1px 2px;border-style:solid;padding:0;overflow:visible;border-color:#ccc!important}.jarviswidget .widget-body{min-height:100px;position:relative;padding-bottom:13px}.jarviswidget .widget-body.widget-hide-overflow{overflow:hidden}.jarviswidget.well.transparent .widget-body.no-padding{margin:0!important}.jarviswidget.well{margin:0 0 30px}.jarviswidget.well>div{border:none!important;box-shadow:none!important;-webkit-box-shadow:none!important;-moz-box-shadow:none!important}.jarviswidget.well header{display:none}.jarviswidget-editbox{display:none;padding:10px}.jarviswidget-timestamp{font-size:12px;color:#868686;font-style:italic;margin:10px 0 0}.jarviswidget-placeholder{border-radius:0;margin-bottom:28px;padding:0;-khtml-box-sizing:border-box;-ms-box-sizing:border-box;box-sizing:border-box}#jarviswidget-fullscreen-mode{width:100%;height:100%;position:fixed;top:0;left:0;z-index:1050}#jarviswidget-fullscreen-mode .jarviswidget{margin:0;border-radius:0}#jarviswidget-fullscreen-mode .jarviswidget>div{overflow-y:scroll;border-radius:0}#jarviswidget-fullscreen-mode>div>header{cursor:default}.jarviswidget>header{color:#333;border:1px solid #c2c2c2;background:#fafafa}.jarviswidget>div{background-color:#fff}.jarviswidget-editbox{border-bottom:1px solid #b1b1b1;background-color:#fff;margin:-13px -13px 13px}.no-padding .jarviswidget-editbox{margin:0 0 10px}.jarviswidget-placeholder{background-color:#ffc;border:1px dashed #a7a7a7}.jarviswidget-remove-colors{color:#333!important;padding:0!important;background:0 0!important}table.dataTable{clear:both;margin-bottom:6px!important;max-width:none!important;margin-top:0!important}table.dataTable td,table.dataTable th{box-sizing:content-box}table.dataTable td.dataTables_empty,table.dataTable th.dataTables_empty{text-align:center}table.dataTable.nowrap td,table.dataTable.nowrap th{white-space:nowrap}div.dataTables_wrapper div.dataTables_length label{font-weight:400;text-align:left;white-space:nowrap}div.dataTables_wrapper div.dataTables_length select{width:75px;display:inline-block}div.dataTables_wrapper div.dataTables_filter{text-align:right}div.dataTables_wrapper div.dataTables_filter label{font-weight:400;white-space:nowrap;text-align:left}div.dataTables_wrapper div.dataTables_filter input{margin-left:.5em;display:inline-block;width:auto}div.dataTables_wrapper div.dataTables_info{padding-top:8px;white-space:nowrap}div.dataTables_wrapper div.dataTables_paginate{margin:0;white-space:nowrap;text-align:right}div.dataTables_wrapper div.dataTables_paginate ul.pagination{margin:2px 0;white-space:nowrap}div.dataTables_wrapper div.dataTables_processing{position:absolute;top:50%;left:50%;width:200px;margin-left:-100px;margin-top:-26px;text-align:center;padding:1em 0}table.dataTable thead>tr>th.sorting,table.dataTable thead>tr>th.sorting_asc,table.dataTable thead>tr>th.sorting_desc,table.dataTable thead>tr>th>div.sorting,table.dataTable thead>tr>th>div.sorting_asc{padding-right:30px;text-align:right}.cus-cursor-pointer{cursor:pointer}.zui-table thead th{padding:10px;margin-top:-1px}.zui-table tbody td{padding:10px}.zui-wrapper{overflow:hidden;position:relative;width:100%}.zui-scroller{overflow-x:auto}.zui-table .zui-sticky-col{border-left:1px solid #ddd;border-right:1px solid #ddd;border-top:1px solid #ddd;border-bottom:1px solid #ddd;left:0;position:absolute;background-color:#f1f1f1}.table-bordered>thead>tr>td,.table-bordered>thead>tr>th{border-bottom-width:0}.pinned-column-bg-color{background-color:#f9f9f9;border-left:1px solid #ddd}.jarviswidget header{padding:0 5px;line-height:40px;background-color:#404040;border:1px solid #404040;color:#fff}.wrap{text-overflow:ellipsis;overflow:hidden;white-space:nowrap}.no-row-margin{margin-left:0!important;margin-right:0!important}.sort-by,.sort-by-asc,.sort-by-desc{padding-right:18px;position:relative;display:block;width:100%}.sort-by-asc:after,.sort-by-asc:before,.sort-by-desc:after,.sort-by-desc:before,.sort-by:after,.sort-by:before{border:4px solid transparent;content:\"\";display:block;height:0;right:5px;top:50%;position:absolute;width:0}.sort-by:before{border-bottom-color:#666;margin-top:-9px}.sort-by:after{border-top-color:#666;margin-top:1px}.sort-by-asc:before{border-bottom-color:#666;margin-top:-6px}.sort-by-desc:after{border-top-color:#666;margin-top:-1px}.custom-pagination-align{text-align:right!important}.custom-data-entries-align{text-align:left!important}.triangle-down{width:0;height:0;border-left:6px solid transparent;border-right:6px solid transparent;border-top:12px solid #555;cursor:pointer}.triangle-right{width:0;height:0;border-top:6px solid transparent;border-left:12px solid #555;border-bottom:6px solid transparent;cursor:pointer}@media screen and (max-width:767px){div.dataTables_wrapper div.dataTables_filter,div.dataTables_wrapper div.dataTables_info,div.dataTables_wrapper div.dataTables_length,div.dataTables_wrapper div.dataTables_paginate{text-align:center}}@media screen and (max-width:576px){.custom-data-entries-align,.custom-pagination-align{text-align:center!important}}"]
                }] }
    ];
    /** @nocollapse */
    NgxDatatableComponent.ctorParameters = function () { return [
        { type: DataShowingService },
        { type: ChangeDetectorRef }
    ]; };
    NgxDatatableComponent.propDecorators = {
        tableId: [{ type: Input }],
        columns: [{ type: Input }],
        data: [{ type: Input }],
        options: [{ type: Input }],
        tableClass: [{ type: Input }],
        rowClick: [{ type: Output }],
        checkboxClick: [{ type: Output }],
        captionRef: [{ type: ContentChild, args: [CaptionComponent, { static: false },] }]
    };
    return NgxDatatableComponent;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    NgxDatatableComponent.prototype.ngUnsubscribe;
    /**
     * @type {?}
     * @private
     */
    NgxDatatableComponent.prototype.customOptions;
    /**
     * @type {?}
     * @private
     */
    NgxDatatableComponent.prototype._options;
    /**
     * @type {?}
     * @private
     */
    NgxDatatableComponent.prototype._data;
    /** @type {?} */
    NgxDatatableComponent.prototype.tableId;
    /** @type {?} */
    NgxDatatableComponent.prototype.columns;
    /** @type {?} */
    NgxDatatableComponent.prototype.tableClass;
    /** @type {?} */
    NgxDatatableComponent.prototype.rowClick;
    /** @type {?} */
    NgxDatatableComponent.prototype.checkboxClick;
    /** @type {?} */
    NgxDatatableComponent.prototype.captionRef;
    /** @type {?} */
    NgxDatatableComponent.prototype.searchText;
    /** @type {?} */
    NgxDatatableComponent.prototype.currentPage;
    /** @type {?} */
    NgxDatatableComponent.prototype.orderBy;
    /** @type {?} */
    NgxDatatableComponent.prototype.dataShowing;
    /** @type {?} */
    NgxDatatableComponent.prototype.styleParams;
    /** @type {?} */
    NgxDatatableComponent.prototype.selectedCheckboxes;
    /** @type {?} */
    NgxDatatableComponent.prototype.selectedCheckList;
    /** @type {?} */
    NgxDatatableComponent.prototype.openRowDetailsId;
    /**
     * @type {?}
     * @private
     */
    NgxDatatableComponent.prototype.dataShowingService;
    /**
     * @type {?}
     * @private
     */
    NgxDatatableComponent.prototype.cdr;
    /* Skipping unhandled member: ;*/
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SearchPipe = /** @class */ (function () {
    function SearchPipe(dataShowingService) {
        this.dataShowingService = dataShowingService;
    }
    /**
     * @param {?} array
     * @param {?} searchText
     * @return {?}
     */
    SearchPipe.prototype.transform = /**
     * @param {?} array
     * @param {?} searchText
     * @return {?}
     */
    function (array, searchText) {
        if (typeof array === 'undefined') {
            return;
        }
        if (typeof searchText === 'undefined' || Object.keys(searchText).length === 0 || searchText === '') {
            this.dataShowingService.setSataShowingSubject({ len: array.length });
            return array;
        }
        /** @type {?} */
        var arr = array.filter((/**
         * @param {?} row
         * @return {?}
         */
        function (row) {
            /** @type {?} */
            var rowDetail = JSON.stringify(Object.values(row));
            return rowDetail.toLowerCase().indexOf(searchText.trim().toLowerCase()) > -1;
        }));
        this.dataShowingService.setSataShowingSubject({ len: arr.length });
        return arr;
    };
    SearchPipe.decorators = [
        { type: Pipe, args: [{
                    name: 'search',
                },] }
    ];
    /** @nocollapse */
    SearchPipe.ctorParameters = function () { return [
        { type: DataShowingService }
    ]; };
    return SearchPipe;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    SearchPipe.prototype.dataShowingService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SortPipe = /** @class */ (function () {
    function SortPipe() {
    }
    /**
     * @param {?} array
     * @param {?} filter
     * @return {?}
     */
    SortPipe.prototype.transform = /**
     * @param {?} array
     * @param {?} filter
     * @return {?}
     */
    function (array, filter) {
        var _this = this;
        // console.log("sort pipe" + JSON.stringify(filter));
        // console.log(array);
        if (!filter.key || filter.key === '') {
            return array;
        }
        if (filter.order === '') {
            return array;
        }
        if (filter.order === 'asc') {
            return array.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) { return _this.compare(a, b, filter.key); }));
        }
        else {
            return array.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) { return _this.compare(b, a, filter.key); }));
        }
    };
    /**
     * @private
     * @param {?} a
     * @param {?} b
     * @param {?} key
     * @return {?}
     */
    SortPipe.prototype.compare = /**
     * @private
     * @param {?} a
     * @param {?} b
     * @param {?} key
     * @return {?}
     */
    function (a, b, key) {
        //return ('' + a[key]).localeCompare(b[key]);
        //console.log(this.isNaN(a, b));
        if (this.isNaN(a[key], b[key])) {
            return ('' + a[key]).localeCompare(b[key]);
        }
        else {
            if (parseFloat(a[key]) < parseFloat(b[key])) {
                return -1;
            }
            if (parseFloat(a[key]) > parseFloat(b[key])) {
                return 1;
            }
        }
        return 0;
    };
    /**
     * @private
     * @param {?} aV
     * @param {?} bV
     * @return {?}
     */
    SortPipe.prototype.isNaN = /**
     * @private
     * @param {?} aV
     * @param {?} bV
     * @return {?}
     */
    function (aV, bV) {
        return (isNaN(parseFloat(aV)) || !isFinite(aV)) || (isNaN(parseFloat(bV)) || !isFinite(bV));
    };
    SortPipe.decorators = [
        { type: Pipe, args: [{
                    name: 'sort',
                    pure: true //default pure = true
                },] }
    ];
    return SortPipe;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxDatatableModule = /** @class */ (function () {
    function NgxDatatableModule() {
    }
    NgxDatatableModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgxDatatableComponent, SearchPipe, SortPipe, CaptionComponent],
                    imports: [
                        FormsModule,
                        CommonModule,
                        NgxPaginationModule
                    ],
                    providers: [],
                    exports: [NgxDatatableComponent, CaptionComponent]
                },] }
    ];
    return NgxDatatableModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxDatatableComponent, NgxDatatableModule, DataShowingService as ɵa, CaptionComponent as ɵb, SearchPipe as ɵc, SortPipe as ɵd };
//# sourceMappingURL=tusharghoshbd-ngx-datatable.js.map
